/**
 * Clase que define la estructura SensorData para guardar los datos del sensor.
 * Autores: Stefano Aguilera, Matias Contreras
 */

package sensado_remoto;

import java.io.*;
import java.lang.Math;
import java.util.ArrayList;
import java.util.concurrent.ThreadLocalRandom;

class SensorData{
	private int size;
	private int numSensors;
	private ArrayList<Sensor> sensors = new ArrayList<Sensor>(); 

	SensorData(int total, int tamanno){
		this.size = tamanno;
		this.numSensors = total;
	}

	public synchronized boolean addSensor(Sensor sensor){
		if(sensors.size() == size)
			return false;

		sensors.add(sensor);
		numSensors++;
		return true;
	}

	public synchronized Sensor getRandomSensor(){
		if(numSensors == 0) return null;

		int rnd = ThreadLocalRandom.current().nextInt(0, numSensors);
		System.out.println("\nSe ha seleccionado un sensor.");
		Sensor auxSensor = sensors.get(rnd);
		sensors.remove(rnd);
		numSensors--;
		return auxSensor;
	}

	public void clearData(){
		sensors.clear();
	}
}
